/*  Programme noyau pour afficher l'heure sur le petit afficheur OLED.

    Les E/S sont compatibles avec celles du programme Éphéméride Solaire.

    Ce programme sert principalement à remettre à l'heure le DS1302.
    Pour lce faire : * Valider la ligne 46,
                     * Corriger les valeurs de la date et de l'heure. Pour l'heure prévoir 10s d'anticipation
                       pour le temps de transfert.
  
  La mise à l'haure n'est pas prévue sur le programme d'Éphéméride Solaire
  car cette dernière n'est utile que lorsque le DS1302 a dérivé ce qui
  nécessite plusieurs années pour aboutir à des valeurs notables.                 */

#include <stdio.h>  // Impératif pour l'HORLOGE DS1302.
#include <DS1302.h> // Bibliothèque pour l'HORLOGE DS1302.

// Dédinir les E/S sur Arduino.
uint8_t LigneRST  = 4;
uint8_t LigneIO   = 5;
uint8_t LigneSCLK = 6;

// Déclarations pour l'afficheur OLED :
#include <Adafruit_ssd1306syp.h>
#define broche_SDA 11 // D11 utilisée en sortie.
#define broche_SCL 12 // D12 utilisée en sortie.
Adafruit_ssd1306syp display(broche_SDA, broche_SCL);

// Creer "l'objet" DS1302.
DS1302 rtc(LigneRST, LigneIO, LigneSCLK);

// @ IMPORTANT : Quand on initialise une date, le DS1302 ne peut pas savoir quel est le JOUR,
//               il faut le lui précise avec le dernier paramètre. 1 pour Lundi, 2 pour mardi,
//               3 pour Mercredi etc. Comme ici ce paramètre n'est pas traité, on peut 
//               arbitrairement mettre 1 par exemple.

void setup() {
  // ========== Bloc à inclure si mise à l'heure désirée. ==========
  /* Initialiser une nouvelle fois le circuit intégré en désactivant
     la protection en écriture et le "drapeau d'arrêt de l'horloge.
     Ces directives ne doivent pas toujours être appelées. Voir en
     détail la fiche d'exploitation du DS1302. */
  // >>> rtc.write_protect(false);
  // >>> rtc.halt(false);
  // Définir la date et l'heure à transmettre au DS1302.
  // Ici le 10 Janvier 2014 à 10h 22 min 40 secondes.
  // >>> Time t(2014, 1, 10, 10, 22, 40, @); Dernier paramètre : Voir @.
  // Transmettre ces informations au circuit intégré.
  // >>> rtc.time(t);
  //==================================================================
//  rtc.write_protect(false); rtc.halt(false); Time t(2017, 4, 17, 19, 45, 50, 1); rtc.time(t);
  //==================================================================
  
  display.initialize(); delay(300); display.setTextSize(1);} // Taille la plus petite.
  
void loop() { AfficheLeTemps(); delay(1000);}

void AfficheLeTemps() { // Télécharger la date et l'heure préservée dans le DS1302.
  Time t = rtc.time();
  display.clear(); display.setCursor(30,20);
  display.print(t.date); display.print(" "); display.print(t.mon); display.print(" "); display.print(t.yr);
  display.setCursor(30,40);
  display.print(t.hr); display.print(" "); display.print(t.min); display.print(" "); display.print(t.sec);
  display.update();}

  
